<?php

/**
 * The file that defines the core plugin class
 *
 * A class definition that includes attributes and functions used across both the
 * public-facing side of the site and the admin area.
 *
 * @link       https://orbicular.media
 * @since      1.0.0
 *
 * @package    Cemetery_Sexton
 * @subpackage Cemetery_Sexton/includes
 */

/**
 * The core plugin class.
 *
 * This is used to define internationalization, admin-specific hooks, and
 * public-facing site hooks.
 *
 * Also maintains the unique identifier of this plugin as well as the current
 * version of the plugin.
 *
 * @since      1.0.0
 * @package    Cemetery_Sexton
 * @subpackage Cemetery_Sexton/includes
 * @author     Bryan Meeks <bryan@orbicular.media>
 */
class Cemetery_Sexton {

	/**
	 * The loader that's responsible for maintaining and registering all hooks that power
	 * the plugin.
	 *
	 * @since    1.0.0
	 * @access   protected
	 * @var      Cemetery_Sexton_Loader    $loader    Maintains and registers all hooks for the plugin.
	 */
	protected $loader;

	/**
	 * The unique identifier of this plugin.
	 *
	 * @since    1.0.0
	 * @access   protected
	 * @var      string    $plugin_name    The string used to uniquely identify this plugin.
	 */
	protected $plugin_name;

	/**
	 * The current version of the plugin.
	 *
	 * @since    1.0.0
	 * @access   protected
	 * @var      string    $version    The current version of the plugin.
	 */
	protected $version;

	/**
	 * Define the core functionality of the plugin.
	 *
	 * Set the plugin name and the plugin version that can be used throughout the plugin.
	 * Load the dependencies, define the locale, and set the hooks for the admin area and
	 * the public-facing side of the site.
	 *
	 * @since    1.1.0
	 */
	public function __construct() {
		if ( defined( 'CEMETERY_SEXTON_VERSION' ) ) {
			$this->version = CEMETERY_SEXTON_VERSION;
		} else {
			$this->version = '1.1.0';
		}
		$this->plugin_name = 'cemetery-sexton';

		$this->load_dependencies();
		$this->set_locale();
		$this->define_admin_hooks();
		$this->define_public_hooks();

	}

	/**
	 * Load the required dependencies for this plugin.
	 *
	 * Include the following files that make up the plugin:
	 *
	 * - Cemetery_Sexton_Loader. Orchestrates the hooks of the plugin.
	 * - Cemetery_Sexton_i18n. Defines internationalization functionality.
	 * - Cemetery_Sexton_Admin. Defines all hooks for the admin area.
	 * - Cemetery_Sexton_Public. Defines all hooks for the public side of the site.
	 *
	 * Create an instance of the loader which will be used to register the hooks
	 * with WordPress.
	 *
	 * @since    1.0.0
	 * @access   private
	 */
	private function load_dependencies() {

		/**
		 * The class responsible for orchestrating the actions and filters of the
		 * core plugin.
		 */
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-cemetery-sexton-loader.php';

		/**
		 * The class responsible for defining internationalization functionality
		 * of the plugin.
		 */
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-cemetery-sexton-i18n.php';
		
		/**
		 * The class responsible for making connetion to the database on frontend and backend
		 * of the plugin.
		 */
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'includes/class-cemetery-sexton-sqlconnect.php';

		/**
		 * The class responsible for defining all actions that occur in the admin area.
		 */
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'admin/class-cemetery-sexton-admin.php';

		/**
		 * The class responsible for defining all actions that occur in the public-facing
		 * side of the site.
		 */
		require_once plugin_dir_path( dirname( __FILE__ ) ) . 'public/class-cemetery-sexton-public.php';

		$this->loader = new Cemetery_Sexton_Loader();

	}

	/**
	 * Define the locale for this plugin for internationalization.
	 *
	 * Uses the Cemetery_Sexton_i18n class in order to set the domain and to register the hook
	 * with WordPress.
	 *
	 * @since    1.0.0
	 * @access   private
	 */
	private function set_locale() {

		$plugin_i18n = new Cemetery_Sexton_i18n();

		$this->loader->add_action( 'plugins_loaded', $plugin_i18n, 'load_plugin_textdomain' );

	}

	/**
	 * Register all of the hooks related to the admin area functionality
	 * of the plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 */
	private function define_admin_hooks() {

		$plugin_admin = new Cemetery_Sexton_Admin( $this->get_plugin_name(), $this->get_version() );

		$this->loader->add_action( 'admin_enqueue_scripts', $plugin_admin, 'enqueue_styles' );
		$this->loader->add_action( 'admin_enqueue_scripts', $plugin_admin, 'enqueue_scripts' );
		
		// Save/Update our plugin options
		//$this->loader->add_action( 'admin_init', $plugin_admin, 'options_update');
		
		// Add menu item to Setting submenu
		$this->loader->add_action( 'admin_menu', $plugin_admin, 'add_plugin_admin_menu' );
		$this->loader->add_action( 'admin_init', $plugin_admin, 'register_setting' );
		
		// Add Settings link to the plugin on plugins page
		$plugin_basename = plugin_basename( plugin_dir_path( __DIR__ ) . $this->plugin_name . '.php' );
		$this->loader->add_filter( 'plugin_action_links_' . $plugin_basename, $plugin_admin, 'add_action_links' );
		
	}

	/**
	 * Register all of the hooks related to the public-facing functionality
	 * of the plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 */
	private function define_public_hooks() {

		$plugin_public = new Cemetery_Sexton_Public( $this->get_plugin_name(), $this->get_version() );

		$this->loader->add_action( 'wp_enqueue_scripts', $plugin_public, 'enqueue_styles' );
		$this->loader->add_action( 'wp_enqueue_scripts', $plugin_public, 'enqueue_scripts' );
		
		// Add shortcodes
		$this->loader->add_shortcode( 'cemetery-sexton-search', $plugin_public, 'cemetery_sexton_search' );
		$this->loader->add_shortcode( 'cemetery-sexton-quick-search', $plugin_public, 'cemetery_sexton_quick_search' );
		$this->loader->add_shortcode( 'cemetery-sexton-results', $plugin_public, 'cemetery_sexton_results' );
		$this->loader->add_shortcode( 'cemetery-sexton-interment', $plugin_public, 'cemetery_sexton_interment' );
		$this->loader->add_shortcode( 'cemetery-sexton-lot', $plugin_public, 'cemetery_sexton_lot' );
		$this->loader->add_shortcode( 'cemetery-sexton-map', $plugin_public, 'cemetery_sexton_map' );
		
		//Process Search Form
		$this->loader->add_action( 'admin_post_cemetery-sexton-process-search', $plugin_public, 'cemetery_sexton_process_search' );
		$this->loader->add_action( 'admin_post_nopriv_cemetery-sexton-process-search', $plugin_public, 'cemetery_sexton_process_search' );
		
		//Show Results page from parameters
		$this->loader->add_filter( 'document_title_parts', $plugin_public, 'cemetery_sexton_page_title' );
		
		//View more results or interment
		//$this->loader->add_action( 'admin_post_cemetery-sexton-process-results', $plugin_public, 'cemetery_sexton_process_results', );
		//$this->loader->add_action( 'admin_post_nopriv_cemetery-sexton-process-results', $plugin_public, 'cemetery_sexton_process_results', );
	}

	/**
	 * Run the loader to execute all of the hooks with WordPress.
	 *
	 * @since    1.0.0
	 */
	public function run() {
		$this->loader->run();
	}

	/**
	 * The name of the plugin used to uniquely identify it within the context of
	 * WordPress and to define internationalization functionality.
	 *
	 * @since     1.0.0
	 * @return    string    The name of the plugin.
	 */
	public function get_plugin_name() {
		return $this->plugin_name;
	}

	/**
	 * The reference to the class that orchestrates the hooks with the plugin.
	 *
	 * @since     1.0.0
	 * @return    Cemetery_Sexton_Loader    Orchestrates the hooks of the plugin.
	 */
	public function get_loader() {
		return $this->loader;
	}

	/**
	 * Retrieve the version number of the plugin.
	 *
	 * @since     1.0.0
	 * @return    string    The version number of the plugin.
	 */
	public function get_version() {
		return $this->version;
	}

}
